### Multinomial Logit model estimation

### f[^̓ǂݍ
Data <- read.csv("G:/mnl/trip_sub4.csv",header=TRUE)
## Count the number of data rows
hh <- nrow(Data)

## p[^l̐ݒ
b0 <- numeric(6)

## Recall that we estimate parameters by maximizing the log-likelihood function, hence we first need to define that function

##### ΐޓx֐̒`#####

fr <- function(x) {
  ### p[^̐錾###
  ## 萔
  b1 <- x[1]
  b2 <- x[2]
   
  ## 
  d1 <- x[3]

  ##@o
  d2 <- x[4]

  ## j_~[
  d3 <- x[5]

  ## H_~[
  d4 <- x[6]
  
  ## ΐޓx̂߂̕ϐ錾
  LL = 0
  
  ### pI͈ȉ3
  ## (shop)
  ## H(dinner)
  ## A(home)
  
  
  ## gťvZFϐɂ
                                        # time               # fare      @@@@@@@@@@@@@@@@@@@@@# constant
  shop   <- exp(d1*Data$/100                                                 @@@@@@+b1*matrix(1,nrow =hh,ncol=1))
  din    <- exp(                       @@@@@@@@@@@@@@@  +d3*Data$j_~[@+d4*Data$H_~[+b2*matrix(1,nrow =hh,ncol=1))
  home   <- exp(                     d2*Data$o         @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@)
                                                    
  
  ### Im̌vZ
  ## ƂȂCeXexp(V)̘a
  deno <- (shop + din + home)
  
  ## ꂼvZ
  Pshop   <- (shop / deno)
  Pdin    <- (din   / deno)
  Phome   <- (home   / deno)
  
  
  ## Im0ɂȂĂ܂ꍇɋN̉
  Pshop   <- (Pshop!=0)  *Pshop   + (Pshop==0)
  Pdin    <- (Pdin!=0)   *Pdin    + (Pdin==0)
  Phome   <- (Phome  !=0)*Phome   + (Phome  ==0)
 
  
  
  
  ## I
  Cshop   <- Data$ړI ==""
  Cdin @@@<- Data$ړI =="H"
  Chome   <- Data$ړI =="A"
 
  
  ## ΐޓx̌vZ
  LL <- colSums(Cshop*log(Pshop) + Cdin*log(Pdin) +
                  Chome  *log(Phome))
  
}

##### ΐޓxfr̍ő剻#####

##p[^l̍œK 
res <- optim(b0,fr,gr=NULL, method = "Nelder-Mead", hessian = TRUE, control=list(fnscale=-1))

## p[^lCwbZs 
b   <- res$par
hhh <- res$hessian

## tľvZ
tval <- b/sqrt(-diag(solve(hhh)))

## ޓx
L0 <- fr(b0)
## ŏIޓx
LL <- res$value

##### o #####
print(res)
## ޓx
print(L0)
## ŏIޓx
print(LL)
## ^2l
print((L0-LL)/L0)
## Cς݃^2l
print((L0-(LL-length(b)))/L0)
##p[^l
print(b)
## tl 
print(tval)


